<?php

namespace patest\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSeatRestrictionsInfo ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfSeatRestrictionsInfo
 * @subpackage Arrays
 */
class ArrayOfSeatRestrictionsInfo extends AbstractStructArrayBase
{
    /**
     * The SeatRestrictionsInfo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \patest\StructType\SeatRestrictionsInfo[]
     */
    public $SeatRestrictionsInfo;
    /**
     * Constructor method for ArrayOfSeatRestrictionsInfo
     * @uses ArrayOfSeatRestrictionsInfo::setSeatRestrictionsInfo()
     * @param \patest\StructType\SeatRestrictionsInfo[] $seatRestrictionsInfo
     */
    public function __construct(array $seatRestrictionsInfo = array())
    {
        $this
            ->setSeatRestrictionsInfo($seatRestrictionsInfo);
    }
    /**
     * Get SeatRestrictionsInfo value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \patest\StructType\SeatRestrictionsInfo[]|null
     */
    public function getSeatRestrictionsInfo()
    {
        return isset($this->SeatRestrictionsInfo) ? $this->SeatRestrictionsInfo : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSeatRestrictionsInfo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSeatRestrictionsInfo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSeatRestrictionsInfoForArrayConstraintsFromSetSeatRestrictionsInfo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSeatRestrictionsInfoSeatRestrictionsInfoItem) {
            // validation for constraint: itemType
            if (!$arrayOfSeatRestrictionsInfoSeatRestrictionsInfoItem instanceof \patest\StructType\SeatRestrictionsInfo) {
                $invalidValues[] = is_object($arrayOfSeatRestrictionsInfoSeatRestrictionsInfoItem) ? get_class($arrayOfSeatRestrictionsInfoSeatRestrictionsInfoItem) : sprintf('%s(%s)', gettype($arrayOfSeatRestrictionsInfoSeatRestrictionsInfoItem), var_export($arrayOfSeatRestrictionsInfoSeatRestrictionsInfoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SeatRestrictionsInfo property can only contain items of type \patest\StructType\SeatRestrictionsInfo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SeatRestrictionsInfo value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \patest\StructType\SeatRestrictionsInfo[] $seatRestrictionsInfo
     * @return \patest\ArrayType\ArrayOfSeatRestrictionsInfo
     */
    public function setSeatRestrictionsInfo(array $seatRestrictionsInfo = array())
    {
        // validation for constraint: array
        if ('' !== ($seatRestrictionsInfoArrayErrorMessage = self::validateSeatRestrictionsInfoForArrayConstraintsFromSetSeatRestrictionsInfo($seatRestrictionsInfo))) {
            throw new \InvalidArgumentException($seatRestrictionsInfoArrayErrorMessage, __LINE__);
        }
        if (is_null($seatRestrictionsInfo) || (is_array($seatRestrictionsInfo) && empty($seatRestrictionsInfo))) {
            unset($this->SeatRestrictionsInfo);
        } else {
            $this->SeatRestrictionsInfo = $seatRestrictionsInfo;
        }
        return $this;
    }
    /**
     * Add item to SeatRestrictionsInfo value
     * @throws \InvalidArgumentException
     * @param \patest\StructType\SeatRestrictionsInfo $item
     * @return \patest\ArrayType\ArrayOfSeatRestrictionsInfo
     */
    public function addToSeatRestrictionsInfo(\patest\StructType\SeatRestrictionsInfo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \patest\StructType\SeatRestrictionsInfo) {
            throw new \InvalidArgumentException(sprintf('The SeatRestrictionsInfo property can only contain items of type \patest\StructType\SeatRestrictionsInfo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SeatRestrictionsInfo[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \patest\StructType\SeatRestrictionsInfo|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \patest\StructType\SeatRestrictionsInfo|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \patest\StructType\SeatRestrictionsInfo|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \patest\StructType\SeatRestrictionsInfo|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \patest\StructType\SeatRestrictionsInfo|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SeatRestrictionsInfo
     */
    public function getAttributeName()
    {
        return 'SeatRestrictionsInfo';
    }
}
